<template>
  <a-spin :spinning="confirmLoading">
    <a-form ref="formRef" class="antd-modal-form" :labelCol="labelCol" :wrapperCol="wrapperCol">
      <a-row>
        <a-col :span="24">
          <a-form-item label="主站点名称" v-bind="validateInfos.mainSiteName">
            <a-input v-model:value="formData.mainSiteName" placeholder="请输入主站点名称" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="主站点URL" v-bind="validateInfos.mainSiteUrl">
            <a-input v-model:value="formData.mainSiteUrl" placeholder="请输入主站点URL" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="线程数" v-bind="validateInfos.threadNumber">
	          <a-input-number v-model:value="formData.threadNumber" placeholder="请输入线程数" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="GO语言文件执行路径" v-bind="validateInfos.goFile">
            <a-input v-model:value="formData.goFile" placeholder="请输入GO语言文件执行路径" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="GO语言文件执行系统类型" v-bind="validateInfos.systemTypeGo">
            <j-dict-select-tag type='radio' v-model:value="formData.systemTypeGo" dictCode="system_type" placeholder="请选择GO语言文件执行系统类型" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="正则表达式" v-bind="validateInfos.regularExpression">
            <a-input v-model:value="formData.regularExpression" placeholder="请输入正则表达式" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="超时时间（秒）" v-bind="validateInfos.timeOut">
	          <a-input-number v-model:value="formData.timeOut" placeholder="请输入超时时间（秒）" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="页面抓取类型" v-bind="validateInfos.grabPage">
            <j-dict-select-tag type='radio' v-model:value="formData.grabPage" dictCode="grab_page_type" placeholder="请选择页面抓取类型" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="回调系统地址" v-bind="validateInfos.stateUrl">
            <a-input v-model:value="formData.stateUrl" placeholder="请输入回调系统地址" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
      </a-row>
    </a-form>
  </a-spin>
</template>

<script lang="ts" setup>
  import { ref, reactive, defineExpose, nextTick, defineProps, computed, onMounted } from 'vue';
  import { defHttp } from '/@/utils/http/axios';
  import { useMessage } from '/@/hooks/web/useMessage';
  import JDictSelectTag from '/@/components/Form/src/jeecg/components/JDictSelectTag.vue';
  import { getValueType } from '/@/utils';
  import { saveOrUpdate } from '../MainSite.api';
  import { Form } from 'ant-design-vue';

  const props = defineProps({
    formDisabled: { type: Boolean, default: false },
    formData: { type: Object, default: ()=>{} },
    formBpm: { type: Boolean, default: true }
  });
  const formRef = ref();
  const useForm = Form.useForm;
  const emit = defineEmits(['register', 'ok']);
  const formData = reactive<Record<string, any>>({
    id: '',
    mainSiteName: '',
    mainSiteUrl: '',
    threadNumber: undefined,
    goFile: '',
    systemTypeGo: '',
    regularExpression: '',
    timeOut: undefined,
    grabPage: '',
    stateUrl: '',
  });
  const { createMessage } = useMessage();
  const labelCol = ref<any>({ xs: { span: 24 }, sm: { span: 5 } });
  const wrapperCol = ref<any>({ xs: { span: 24 }, sm: { span: 16 } });
  const confirmLoading = ref<boolean>(false);
  //表单验证
  const validatorRules = {
    mainSiteName: [{ required: true, message: '请输入主站点名称!'},],
    mainSiteUrl: [{ required: true, message: '请输入主站点URL!'},],
    threadNumber: [{ required: true, message: '请输入线程数!'},],
    goFile: [{ required: true, message: '请输入GO语言文件执行路径!'},],
    systemTypeGo: [{ required: true, message: '请输入GO语言文件执行系统类型!'},],
    regularExpression: [{ required: true, message: '请输入正则表达式!'},],
    timeOut: [{ required: true, message: '请输入超时时间（秒）!'},],
    grabPage: [{ required: true, message: '请输入页面抓取类型!'},],
    stateUrl: [{ required: true, message: '请输入回调系统地址!'},],
  };
  const { resetFields, validate, validateInfos } = useForm(formData, validatorRules, { immediate: true });

  // 表单禁用
  const disabled = computed(()=>{
    if(props.formBpm === true){
      if(props.formData.disabled === false){
        return false;
      }else{
        return true;
      }
    }
    return props.formDisabled;
  });


  /**
   * 新增
   */
  function add() {
    edit({});
  }

  /**
   * 编辑
   */
  function edit(record) {
    nextTick(() => {
      resetFields();
      //赋值
      Object.assign(formData, record);
    });
  }

  /**
   * 提交数据
   */
  async function submitForm() {
    // 触发表单验证
    await validate();
    confirmLoading.value = true;
    const isUpdate = ref<boolean>(false);
    //时间格式化
    let model = formData;
    if (model.id) {
      isUpdate.value = true;
    }
    //循环数据
    for (let data in model) {
      //如果该数据是数组并且是字符串类型
      if (model[data] instanceof Array) {
        let valueType = getValueType(formRef.value.getProps, data);
        //如果是字符串类型的需要变成以逗号分割的字符串
        if (valueType === 'string') {
          model[data] = model[data].join(',');
        }
      }
    }
    await saveOrUpdate(model, isUpdate.value)
      .then((res) => {
        if (res.success) {
          createMessage.success(res.message);
          emit('ok');
        } else {
          createMessage.warning(res.message);
        }
      })
      .finally(() => {
        confirmLoading.value = false;
      });
  }


  defineExpose({
    add,
    edit,
    submitForm,
  });
</script>

<style lang="less" scoped>
  .antd-modal-form {
    min-height: 500px !important;
    overflow-y: auto;
    padding: 14px 14px 14px 14px;
  }
</style>
